/*********************************************************************

 Author        : ADI - Apps            www.analog.com/MicroConverter

 Date          : Dec. 2006

 File          : KERNEL_FLASH_TEST.c

 Hardware      : Applicable to ADuC703x

 Description   : FLASH tests Kernel CHECK
 				 Software reset
				 Watchdog reset.
		
*********************************************************************/

#include <ADuC7038.h>

void delay(int);
int status = 0;
int con_status = 0;

int main()
{

    GPCON = 0x00000000;		// all GPIOs
    GPDAT = 0x3F030000;		// Set all bits to outputs	- high
	delay(2000);
	GPCLR = 0x00030000;		// Set all bits to  High
	
	status = FEESTA;
	while (FEESTA & 0x04);	// wait for the FLASH Controllor to be free.
	status = FEESTA;


	FEEMOD = 0x08; 			// Allow Single Write 
	FEEADR = 0x01FC;		//address0x8f000
	FEEDAT = 0x0000;
	FEECON = 0x05; 			// Singl ERASE 	
	status = FEESTA;
	while (FEESTA & 0x04); //CHECK for Fail

	status = FEESTA;
	while (FEESTA & 0x04);	// wait for the FLASH Controllor to be free.
	status = FEESTA;

	FEEMOD = 0x08; 			// Allow Single Write 
	FEEADR = 0x01FC;		//address0x8f000
	FEEDAT = 0x0000;
	FEECON = 0x02; 			// Singl WRITE base 	
	status = FEESTA;
	while (FEESTA & 0x04); //CHECK for Fail							

	FEEMOD = 0x08; 			// Allow Single Write 
	FEEADR = 0x01FE;		//address0x8ffff
	FEEDAT = 0x1640;
	FEECON = 0x02; 			// Singl WRITE +2  	
	status = FEESTA;
	con_status = FEECON;
	while (FEESTA & 0x04); //CHECK for Fail
 	status = FEESTA;

/*	while(FEESTA & 0x04)	// command Failed ?										
	{
	status = FEESTA;
	GPCLR = 0x000F0000;		// Set all bits to  High
	delay(2000);
	GPSET = 0x000F0000;		// Set all bits to Enable LIN Driver High
	}						// Infinite Loop
  */

	delay(20000000);
	GPSET = 0x00020000;		// Set all bits to Enable LIN Driver High
	delay(2000);
	GPCLR = 0x00020000;		// Set all bits to  High
 //   RSTSTA = 0x04;			 // SW RESET

 	// watchdog RESET
//	T2CLRI = 0;			// comile here and DOWNLOAD through LIN dongle
//	  T2LD = 0x00ff;   // full scale 524 sec	/256 = 2 sec	  - core clock
//	  T2CON = 0xa8;		// 256 prescaler .. 2 sec. WATCHDOG - see rough Work
  
	while (1)
	{
	GPSET = 0x0003F0000;		// Set all bits to Enable LIN Driver High
	delay(200000);
	GPCLR = 0x0003F0000;		// Set all bits to  High
	delay(200000);
	}
}
  
void delay (int length)
{
	while (length >=0)
    	length--;
}
